merging in epoch date usage - allows script to be run more than once a day

This commit is contained in:
Colin Johnson 2014-04-12 21:21:28 +00:00
parent 0257aedd3e
commit 476b4da4c0
2 changed files with 63 additions and 67 deletions

View File

@ -1,8 +1,8 @@
#!/bin/bash - #!/bin/bash -
# Author: Colin Johnson / colin@cloudavail.com # Author: Colin Johnson / colin@cloudavail.com
# Contributors: buckelij / https://github.com/buckelij # Contributors: buckelij / https://github.com/buckelij
# Date: 2014-03-02 # Date: 2014-04-12
# Version 0.1 # Version 0.9
# License Type: GNU GENERAL PUBLIC LICENSE, Version 3 # License Type: GNU GENERAL PUBLIC LICENSE, Version 3
# #

View File

@ -1,9 +1,18 @@
#!/bin/bash - #!/bin/bash -
# Author: Colin Johnson / colin@cloudavail.com # Date: 2014-04-12
# Date: 2013-02-13 # Version 0.10
# Version 0.9
# License Type: GNU GENERAL PUBLIC LICENSE, Version 3 # License Type: GNU GENERAL PUBLIC LICENSE, Version 3
# # Author:
# Colin Johnson / https://github.com/colinbjohnson / colin@cloudavail.com
# Contributors:
# Alex Corley / https://github.com/anthroprose
# Jon Higgs / https://github.com/jonhiggs
# Mike / https://github.com/eyesis
# Jeff Vogt / https://github.com/jvogt
# Dave Stern / https://github.com/davestern
# Josef / https://github.com/J0s3f
# buckelij / https://github.com/buckelij
#confirms that executables required for succesful script execution are available #confirms that executables required for succesful script execution are available
prerequisite_check() prerequisite_check()
{ {
@ -27,7 +36,7 @@ get_EBS_List()
fi fi
ebs_selection_string="$volumeid" ebs_selection_string="$volumeid"
;; ;;
tag) tag)
if [[ -z $tag ]] if [[ -z $tag ]]
then echo "The selected selection_method \"tag\" (-s tag) requires a valid tag (-t key=value) for operation. Correct usage is as follows: \"-s tag -t backup=true\" or \"-s tag -t Name=my_tag.\"" 1>&2 ; exit 64 then echo "The selected selection_method \"tag\" (-s tag) requires a valid tag (-t key=value) for operation. Correct usage is as follows: \"-s tag -t backup=true\" or \"-s tag -t Name=my_tag.\"" 1>&2 ; exit 64
fi fi
@ -43,35 +52,34 @@ get_EBS_List()
then echo -e "An error occured when running ec2-describe-volumes. The error returned is below:\n$ebs_backup_list_complete" 1>&2 ; exit 70 then echo -e "An error occured when running ec2-describe-volumes. The error returned is below:\n$ebs_backup_list_complete" 1>&2 ; exit 70
fi fi
ebs_backup_list=`echo "$ebs_backup_list_complete" | grep ^VOLUME | cut -f 2` ebs_backup_list=`echo "$ebs_backup_list_complete" | grep ^VOLUME | cut -f 2`
#code to right will output list of EBS volumes to be backed up: echo -e "Now outputting ebs_backup_list:\n$ebs_backup_list"
} }
create_EBS_Snapshot_Tags() create_EBS_Snapshot_Tags()
{ {
#snapshot tags holds all tags that need to be applied to a given snapshot - by aggregating tags we ensure that ec2-create-tags is called only onece #snapshot tags holds all tags that need to be applied to a given snapshot - by aggregating tags we ensure that ec2-create-tags is called only onece
snapshot_tags="" snapshot_tags=""
#if $name_tag_create is true then append ec2ab_${ebs_selected}_$date_current to the variable $snapshot_tags #if $name_tag_create is true then append ec2ab_${ebs_selected}_$current_date to the variable $snapshot_tags
if $name_tag_create if $name_tag_create
then then
# possible duplicate code ec2_snapshot_resource_id=`echo "$ec2_create_snapshot_result" | cut -f 2` # possible duplicate code ec2_snapshot_resource_id=`echo "$ec2_create_snapshot_result" | cut -f 2`
ec2_snapshot_resource_id=`echo "$ec2_create_snapshot_result" | cut -f 2` ec2_snapshot_resource_id=`echo "$ec2_create_snapshot_result" | cut -f 2`
snapshot_tags="$snapshot_tags --tag Name=ec2ab_${ebs_selected}_$date_current" snapshot_tags="$snapshot_tags --tag Name=ec2ab_${ebs_selected}_$current_date"
fi fi
#if $hostname_tag_create is true then append --tag InitiatingHost=`hostname -f` to the variable $snapshot_tags #if $hostname_tag_create is true then append --tag InitiatingHost=`hostname -f` to the variable $snapshot_tags
if $hostname_tag_create if $hostname_tag_create
then then
snapshot_tags="$snapshot_tags --tag InitiatingHost='`hostname -f`'" snapshot_tags="$snapshot_tags --tag InitiatingHost='`hostname -f`'"
fi fi
#if $purge_after_days is true, then append $purge_after_date to the variable $snapshot_tags #if $purge_after_date_fe is true, then append $purge_after_date_fe to the variable $snapshot_tags
if [[ -n $purge_after_days ]] if [[ -n $purge_after_date_fe ]]
then then
snapshot_tags="$snapshot_tags --tag PurgeAfter=$purge_after_date --tag PurgeAllow=true" snapshot_tags="$snapshot_tags --tag PurgeAfterFE=$purge_after_date_fe --tag PurgeAllow=true"
fi fi
#if $user_tags is true, then append Volume=$ebs_selected and Created=$current_date to the variable $snapshot_tags #if $user_tags is true, then append Volume=$ebs_selected and Created=$current_date to the variable $snapshot_tags
if $user_tags if $user_tags
then then
snapshot_tags="$snapshot_tags --tag Volume=${ebs_selected} --tag Created=$date_current" snapshot_tags="$snapshot_tags --tag Volume=${ebs_selected} --tag Created=$current_date"
fi fi
#if $snapshot_tags is not zero length then set the tag on the snapshot using ec2-create-tags #if $snapshot_tags is not zero length then set the tag on the snapshot using ec2-create-tags
@ -81,7 +89,7 @@ create_EBS_Snapshot_Tags()
fi fi
} }
date_binary_get() get_date_binary()
{ {
#`uname -o (operating system) would be ideal, but OS X / Darwin does not support to -o option` #`uname -o (operating system) would be ideal, but OS X / Darwin does not support to -o option`
#`uname` on OS X defaults to `uname -s` and `uname` on GNU/Linux defaults to `uname -s` #`uname` on OS X defaults to `uname -s` and `uname` on GNU/Linux defaults to `uname -s`
@ -93,59 +101,46 @@ date_binary_get()
esac esac
} }
get_purge_after_date() get_purge_after_date_fe()
{ {
case $purge_after_input in
#any number of numbers followed by a letter "d" or "days" multiplied by 86400 (number of seconds in a day)
[0-9]*d) purge_after_value_seconds=$(( ${purge_after_input%?} * 86400 )) ;;
#any number of numbers followed by a letter "h" or "hours" multiplied by 3600 (number of seconds in an hour)
[0-9]*h) purge_after_value_seconds=$(( ${purge_after_input%?} * 3600 )) ;;
#any number of numbers followed by a letter "m" or "minutes" multiplied by 60 (number of seconds in a minute)
[0-9]*m) purge_after_value_seconds=$(( ${purge_after_input%?} * 60 ));;
#no trailing digits default is days - multiply by 86400 (number of minutes in a day)
*) purge_after_value_seconds=$(( $purge_after_input * 86400 ));;
esac
#based on the date_binary variable, the case statement below will determine the method to use to determine "purge_after_days" in the future #based on the date_binary variable, the case statement below will determine the method to use to determine "purge_after_days" in the future
case $date_binary in case $date_binary in
linux-gnu) echo `date -d +${purge_after_days}days -u +%Y-%m-%d` ;; linux-gnu) echo `date -d +${purge_after_value_seconds}sec -u +%s` ;;
osx-posix) echo `date -v+${purge_after_days}d -u +%Y-%m-%d` ;; osx-posix) echo `date -v +${purge_after_value_seconds}S -u +%s` ;;
*) echo `date -d +${purge_after_days}days -u +%Y-%m-%d` ;; *) echo `date -d +${purge_after_value_seconds}sec -u +%s` ;;
esac
}
get_purge_after_date_epoch()
{
#based on the date_binary variable, the case statement below will determine the method to use to determine "purge_after_date_epoch" in the future
case $date_binary in
linux-gnu) echo `date -d $purge_after_date +%s` ;;
osx-posix) echo `date -j -f "%Y-%m-%d" $purge_after_date "+%s"` ;;
*) echo `date -d $purge_after_date +%s` ;;
esac
}
get_date_current_epoch()
{
#based on the date_binary variable, the case statement below will determine the method to use to determine "date_current_epoch" in the future
case $date_binary in
linux-gnu) echo `date -d $date_current +%s` ;;
osx-posix) echo `date -j -f "%Y-%m-%d" $date_current "+%s"` ;;
*) echo `date -d $date_current +%s` ;;
esac esac
} }
purge_EBS_Snapshots() purge_EBS_Snapshots()
{ {
#snapshot_tag_list is a string that contains all snapshots with either the key PurgeAllow or PurgeAfter set #snapshot_tag_list is a string that contains all snapshots with either the key PurgeAllow or PurgeAfterFE set
snapshot_tag_list=`ec2-describe-tags --show-empty-fields --region $region --filter resource-type=snapshot --filter key=PurgeAllow,PurgeAfter` snapshot_tag_list=`ec2-describe-tags --show-empty-fields --region $region --filter resource-type=snapshot --filter key=PurgeAllow,PurgeAfterFE`
#snapshot_purge_allowed is a list of all snapshot_ids with PurgeAllow=true #snapshot_purge_allowed is a list of all snapshot_ids with PurgeAllow=true
snapshot_purge_allowed=`echo "$snapshot_tag_list" | grep .*PurgeAllow'\s'true | cut -f 3` snapshot_purge_allowed=`echo "$snapshot_tag_list" | grep .*PurgeAllow'\s'true | cut -f 3`
for snapshot_id_evaluated in $snapshot_purge_allowed for snapshot_id_evaluated in $snapshot_purge_allowed
do do
#gets the "PurgeAfter" date which is in UTC with YYYY-MM-DD format (or %Y-%m-%d) #gets the "PurgeAfterFE" date which is in UTC with UNIX Time format (or xxxxxxxxxx / %s)
purge_after_date=`echo "$snapshot_tag_list" | grep .*$snapshot_id_evaluated'\s'PurgeAfter.* | cut -f 5` purge_after_date_fe_tag=`echo "$snapshot_tag_list" | grep .*$snapshot_id_evaluated'\s'PurgeAfterFE.* | cut -f 5`
#if purge_after_date is not set then we have a problem. Need to alert user. #if purge_after_date is not set then we have a problem. Need to alert user.
if [[ -z $purge_after_date ]] if [[ -z $purge_after_date_fe_tag ]]
#Alerts user to the fact that a Snapshot was found with PurgeAllow=true but with no PurgeAfter date. #Alerts user to the fact that a Snapshot was found with PurgeAllow=true but with no PurgeAfterFE date.
then echo "A Snapshot with the Snapshot ID $snapshot_id_evaluated has the tag \"PurgeAllow=true\" but does not have a \"PurgeAfter=YYYY-MM-DD\" date. $app_name is unable to determine if $snapshot_id_evaluated should be purged." 1>&2 then echo "A Snapshot with the Snapshot ID $snapshot_id_evaluated has the tag \"PurgeAllow=true\" but does not have a \"PurgeAfterFE=xxxxxxxxxx\" date where PurgeAfterFE is UNIX time. $app_name is unable to determine if $snapshot_id_evaluated should be purged." 1>&2
else else
#convert both the date_current and purge_after_date into epoch time to allow for comparison #perform comparison - if $purge_after_date_epoch is a lower number than $current_date_epoch than the PurgeAfterFE date is earlier than the current date - and the snapshot can be safely removed
date_current_epoch=`get_date_current_epoch` if [[ $purge_after_date_fe_tag < $current_date ]]
purge_after_date_epoch=`get_purge_after_date_epoch`
#perform compparison - if $purge_after_date_epoch is a lower number than $date_current_epoch than the PurgeAfter date is earlier than the current date - and the snapshot can be safely removed
if [[ $purge_after_date_epoch < $date_current_epoch ]]
then then
echo "The snapshot \"$snapshot_id_evaluated\" with the Purge After date of $purge_after_date will be deleted." echo "The snapshot \"$snapshot_id_evaluated\" with the PurgeAfterFE date of $purge_after_date_fe_tag will be deleted."
ec2-delete-snapshot --region $region $snapshot_id_evaluated ec2-delete-snapshot --region $region $snapshot_id_evaluated
fi fi
fi fi
@ -161,9 +156,9 @@ date_binary=""
name_tag_create=false name_tag_create=false
#sets the "InitiatingHost" tag set for a snapshot to false #sets the "InitiatingHost" tag set for a snapshot to false
hostname_tag_create=false hostname_tag_create=false
#sets the user_tags feature to false - user_tag creates tags on snapshots - by default each snapshot is tagged with volume_id and current_data timestamp #sets the user_tags feature to false - user_tag creates tags on snapshots - by default each snapshot is tagged with volume_id and current_date timestamp
user_tags=false user_tags=false
#sets the Purge Snapshot feature to false - this feature will eventually allow the removal of snapshots that have a "PurgeAfter" tag that is earlier than current date #sets the Purge Snapshot feature to false - this feature will eventually allow the removal of snapshots that have a "PurgeAfterFE" tag that is earlier than current date
purge_snapshots=false purge_snapshots=false
#handles options processing #handles options processing
@ -175,7 +170,7 @@ while getopts :s:c:r:v:t:k:pnhu opt
r) region="$OPTARG";; r) region="$OPTARG";;
v) volumeid="$OPTARG";; v) volumeid="$OPTARG";;
t) tag="$OPTARG";; t) tag="$OPTARG";;
k) purge_after_days="$OPTARG";; k) purge_after_input="$OPTARG";;
n) name_tag_create=true;; n) name_tag_create=true;;
h) hostname_tag_create=true;; h) hostname_tag_create=true;;
p) purge_snapshots=true;; p) purge_snapshots=true;;
@ -186,7 +181,7 @@ while getopts :s:c:r:v:t:k:pnhu opt
#sources "cron_primer" file for running under cron or other restricted environments - this file should contain the variables and environment configuration required for ec2-automate-backup to run correctly #sources "cron_primer" file for running under cron or other restricted environments - this file should contain the variables and environment configuration required for ec2-automate-backup to run correctly
if [[ -n $cron_primer ]] if [[ -n $cron_primer ]]
then if [[ -f $cron_primer ]] then if [[ -f $cron_primer ]]
then source $cron_primer then source $cron_primer
else else
echo "Cron Primer File \"$cron_primer\" Could Not Be Found." 1>&2 ; exit 70 echo "Cron Primer File \"$cron_primer\" Could Not Be Found." 1>&2 ; exit 70
@ -197,7 +192,7 @@ fi
if [[ -z $region ]] if [[ -z $region ]]
#if the environment variable $EC2_REGION is not set set to us-east-1 #if the environment variable $EC2_REGION is not set set to us-east-1
then if [[ -z $EC2_REGION ]] then if [[ -z $EC2_REGION ]]
#if both #if both
then region="us-east-1" then region="us-east-1"
else else
region=$EC2_REGION region=$EC2_REGION
@ -208,16 +203,17 @@ fi
prerequisite_check prerequisite_check
#sets date variable #sets date variable
date_current=`date -u +%Y-%m-%d` current_date=`date -u +%s`
#sets the PurgeAfter tag to the number of days that a snapshot should be retained
if [[ -n $purge_after_days ]] #sets the PurgeAfterFE tag to the number of seconds that a snapshot should be retained
if [[ -n $purge_after_input ]]
then then
#if the date_binary is not set, call the date_binary_get function #if the date_binary is not set, call the get_date_binary function
if [[ -z $date_binary ]] if [[ -z $date_binary ]]
then date_binary_get then get_date_binary
fi fi
purge_after_date=`get_purge_after_date` purge_after_date_fe=`get_purge_after_date_fe`
echo "Snapshots taken by $app_name will be eligible for purging after the following date: $purge_after_date." echo "Snapshots taken by $app_name will be eligible for purging after the following date (the purge after date given in seconds from epoch): $purge_after_date_fe."
fi fi
#get_EBS_List gets a list of EBS instances for which a snapshot is desired. The list of EBS instances depends upon the selection_method that is provided by user input #get_EBS_List gets a list of EBS instances for which a snapshot is desired. The list of EBS instances depends upon the selection_method that is provided by user input
@ -226,13 +222,13 @@ get_EBS_List
#the loop below is called once for each volume in $ebs_backup_list - the currently selected EBS volume is passed in as "ebs_selected" #the loop below is called once for each volume in $ebs_backup_list - the currently selected EBS volume is passed in as "ebs_selected"
for ebs_selected in $ebs_backup_list for ebs_selected in $ebs_backup_list
do do
ec2_snapshot_description="ec2ab_${ebs_selected}_$date_current" ec2_snapshot_description="ec2ab_${ebs_selected}_$current_date"
ec2_create_snapshot_result=`ec2-create-snapshot --region $region -d $ec2_snapshot_description $ebs_selected 2>&1` ec2_create_snapshot_result=`ec2-create-snapshot --region $region -d $ec2_snapshot_description $ebs_selected 2>&1`
if [[ $? != 0 ]] if [[ $? != 0 ]]
then echo -e "An error occured when running ec2-create-snapshot. The error returned is below:\n$ec2_create_snapshot_result" 1>&2 ; exit 70 then echo -e "An error occured when running ec2-create-snapshot. The error returned is below:\n$ec2_create_snapshot_result" 1>&2 ; exit 70
else else
ec2_snapshot_resource_id=`echo "$ec2_create_snapshot_result" | cut -f 2` ec2_snapshot_resource_id=`echo "$ec2_create_snapshot_result" | cut -f 2`
fi fi
create_EBS_Snapshot_Tags create_EBS_Snapshot_Tags
done done